10 REMark $$chan=3
11 REMark $$stak=512
12 REMark $$heap=64
13 remark $$asmb=dev4_toox_fil_bin_FSEL_BIN,0,10
14 :
15 EXT_FN 'FILE_SELECT$'
16 :
17 EXT_PROC 'POKESTR$', 'SCRXY', 'GPT'
18 EXT_FN 'DETAB$', 'ODD', 'VALID%'
19 :
20 rem + ************************************************************************ +
21 rem *<                                  FSEL                                  >*
22 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
23 rem *                         Wrapper for FILE_SELECT                          *
24 rem *                                                                          *
25 rem * pjwitte 2oo2++                                                          *
26 rem + ------------------------------------------------------------------------ +
27 rem * V0.03 - error handling                                                   *
28 rem * V0.04, pjw, December 16th 2016, new command line handling                *
29 rem * V0.05, pjw, July 26th 2017, WAKE owner on return, if asleep              *
30 rem * V0.10, pjw, 2019 Jul 26, Neutralise errors, new toolkit (0.05 removed)   *
31 rem * V0.11, pjw, 2021 Aug 24, Boundry check: Window > display fixed           *
32 rem * V0.12, pjw, 2021 Nov 09, Improved default handling of filename and posn. *
33 rem + ************************************************************************ +
34 :
35 :
36 rem $$off
37 if peek$(\\-4, 4) = 'SBAS' then
38  lrespr home_dir$ & 'bin_FSEL_bin'
39  job_name 'FSEL'
40 endif
41 rem $$on
42 :
43 quote$          = '"' & "'":    rem Quote charcters
44 :
45 REMark Defaults
46 tit$ = 'Select File'
47 :
48 gpt xpos%, ypos%
49 xsz% = 448
50 ysz% = 240
51 cwm% = 0
52 cwf% = 0
53 :
54 GetCMD CMD$ : rem No more errors; use fallback values instead
55 rem  ert GetCmd('/X32 /Y56 /D win1_prg_ /F win1_prg_  /P 00000003')
56 :
57 scrxy scx%, scy%
58 ch = FOPEN(#0; "con_"): IF ch < 0: Bye ch
59 SetPal
60 :
61 REMark Check boundaries
62 if xsz% > scx%: xsz% = scx%
63 if ysz% > scy%: ysz% = scy%
64 IF xpos% < 0 THEN
65  xpos% = 0
66 ELSE
67  IF (xpos% + xsz%) > scx%: xpos% = scx% - xsz%
68 END IF
69 IF ypos% < 0 THEN
70  ypos% = 0
71 ELSE
72  IF (ypos% + ysz%) > scy%: ypos% = scy% - ysz%
73 END IF
74 :
75 REMark FILE_SELECT$ requires an outline
76 REMark OUTLN is part of SMSQ/E & Qptr - otherwise load toolkit
77 OUTLN#ch; xsz%, ysz%, xpos%, ypos%
78 :
79 x$ = FILE_SELECT$(tit$, fnm$, dir$, ext$, 0, 0, 0): rem , cwm%, cwf%)
80 if retadd: pokestr$ retadd, x$
81 :
82 Bye 0
83 :
84 :
85 rem + ------------------------------------------------------------------------ +
86 rem |<                                 GetCMD                                 >|
87 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
88 rem | Parse Command line                                                       |
89 rem |  This is QIOT's standard command line parser. Fill in the details as     |
90 rem | required.                                                                |
91 rem | Dependencies:                                                            |
92 rem |  Requires VALID% & DETAB$                                                |
93 rem |  fn GetEnt$                                                              |
94 rem + ------------------------------------------------------------------------ +
95 rem |  V0.01, pjw, November 29th 2016                                          |
96 rem |  V0.02, pjw, 2019 Jul 26, new VALID% and DETAB$                          |
97 rem |  V0.02, Special case for FSEL: No errors; FN -> PROC                     |
98 rem + ------------------------------------------------------------------------ +
99 :
100 def proc GetCMD(cl$)
101 loc t$
102 rem GLOBal xpos%, ypos%, palette, retadd, ..
103 :
104 rem Get pointer position
105 t$ = Getent$("X")
106 if valid%(3, t$): xpos% = t$
107 t$ = Getent$("Y")
108 if valid%(3, t$): ypos% = t$
109 :
110 rem Get size
111 t$ = Getent$("W")
112 if valid%(3, t$): xsz% = t$
113 t$ = Getent$("H")
114 if valid%(3, t$): ysz% = t$
115 :
116 rem Title
117 t$ = Getent$("T")
118 if t$ <> '*': tit$ = t$
119 :
120 rem Directory
121 t$ = Getent$("D")
122 if t$ = '*' then
123  dir$ = ''
124 else
125  dir$ = t$
126  if len(dir$) then
127   if dir$(len(dir$)) <> '_': dir$ = dir$ & '_'
128  endif
129 endif
130 :
131 rem Extension
132 t$ = Getent$("E")
133 if t$ = '*' then
134  ext$ = ''
135 else
136  ext$ = t$
137  if len(ext$) then
138   if not ext$(1) instr '_.': ext$ = '_' & ext$
139  endif
140 endif
141 :
142 rem File name
143 t$ = Getent$("F")
144 if t$ <> '*' then
145  fnm$ = t$
146 else
147  if len(dir$) then
148   fnm$ = dir$ & ext$
149  else
150   fnm$ = GetStuff$
151  endif
152 endif
153 :
154 if len(dir$) = 0: dir$ = datad$
155 :
156 rem Get palette
157 palette = 0: rem Default
158 t$ = Getent$("P")
159 if t$ <> '*' then
160  if len(t$) = 1
161   if valid%(3, t$) then
162    palette = t$
163    if palette < 0 or palette > 3: palette = 0
164   endif
165  else
166   palette = ValidHex(t$, 8)
167   if odd(palette): palette = 0: rem Not even
168  endif
169 endif
170 :
171 rem Get return address
172 t$ = Getent$("R")
173 retadd = ValidHex(t$, 8)
174 if odd(retadd): retadd = 0
175 enddef GetCmd
176 :
177 def fn Getent$(k$)
178 loc p%, t$
179 rem Caller's cl$
180 rem Given the character get the entry
181 rem /C [<spaces>] ["|'] <entry> ["|'] <space> | / | <eol>
182 rem Doesnt check if quotes match. Doesnt accept literal /
183 :
184 p% = '/' & k$ instr cl$
185 if p% = 0: ret '*'
186 t$ = detab$(cl$(p% + 2 to len(cl$)))
187 p% = '/' instr t$
188 if p% > 0: t$ = t$(1 to p%): else: p% = len(t$)
189 for p% = len(t$) to 1 step -1
190  if not t$(p%) instr ' /': exit p%
191 endfor p%
192 :
193 t$ = t$(1 to p%)
194 if len(t$) > 1 then
195  p% = t$(1) instr quote$
196  if p% then
197   if (t$(len(t$)) instr quote$) = p% then
198    t$ = t$(2 to len(t$) - 1)
199 endif: endif: endif
200 ret t$
201 enddef Getent$
202 :
203 :
204 def proc Setpal
205 if palette > 3 then
206  sp_jobownpal -1, palette: rem Use calling job's private palette
207 else
208  sp_jobpal -1, palette: rem Use system palette
209 endif
210 enddef Setpal
211 :
212 def proc Bye(er)
213 if er < 0 then
214  IF retadd > 0 then
215   pokestr$ retadd, '' & er
216  else
217   ert er
218  endif
219 endif
220 enddef Bye
221 :
222 :
223 rem + ------------------------------------------------------------------------ +
224 rem |<                                ValidHex                                >|
225 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
226 rem |             Validate a hex string and return its value or 0              |
227 rem |                                                                          |
228 rem | A valid hex string is a string of numbers and hex digits, optionally     |
229 rem | prefixed by a $ sign. The (max) number of valid hex digits expected      |
230 rem | may be specified in l% (1..8).                                           |
231 rem | The routine tries to behave like S*BASIC's integer parser, in that       |
232 rem | invalid characters at the end of the string are ignored. Fewer digits    |
233 rem | than specified are also accepted as legal.                               |
234 rem | An invalid hex string is returned as zero!                               |
235 rem + ------------------------------------------------------------------------ +
236 rem | V0.02, pjw, 2019 Jul 02                                                  |
237 rem + ------------------------------------------------------------------------ +
238 :
239 DEFine FuNction ValidHex(h$, l%)
240 LOCal i%, d%, s%, e%
241 :
242 i% = LEN(h$): s% = 1: d% = 0
243 IF i% > 1 THEN
244  IF h$(1) = '$': s% = 2
245 END IF
246 IF i% > l%: e% = l%: ELSE : e% = i%
247 :
248 FOR i% = s% TO e%
249  IF NOT (h$(i%) INSTR '0123456789ABCDEF'): EXIT i%
250  d% = d% + 1
251 END FOR i%
252 :
253 IF d% > 0: RETurn HEX(h$(s% TO s% + d%))
254 RETurn 0
255 END DEFine ValidHex
256 :
257 :
258 rem + ------------------------------------------------------------------------ +
259 rem |<                               GetStuff$                                >|
260 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
261 rem |            Return the first filename found in Stuffer Buffer             |
262 rem |                                                                          |
263 rem | If no filename found return Default. Only scans the five last entries    |
264 rem |                                                                          |
265 rem | Dependency: VALID%()                                                     |
266 rem + ------------------------------------------------------------------------ +
267 rem | V0.01, pjw, 2021 Nov 09                                                  |
268 rem + ------------------------------------------------------------------------ +
269 :
270 DEFine FuNction GetStuff$
271 LOCal lp, i%, c%
272 i% = 0: c% = 0
273 REPeat lp
274  f$ = HOT_GETSTUFF$(i%)
275  IF LEN(f$) >= 5 then
276   IF VALID%(3, f$(4)): RETurn f$
277   IF VALID%(3, f$(2)): RETurn f$
278  endif
279  c% = c% + 1: IF c% > 4: EXIT lp
280  i% = -1
281 END REPeat lp
282 RETurn DATAD$
283 END DEFine GetStuff$
284 :
285 :
